



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python的深copy和浅copy</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python的深copy和浅copy</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 01:41:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<ul><li><strong>浅拷贝(copy)：</strong>拷贝父对象，不会拷贝对象的内部的子对象。</li>
<li><strong>深拷贝(deepcopy)：</strong> copy 模块的 deepcopy 方法，完全拷贝了父对象及其子对象。</li></ul>
<p><strong>浅copy：</strong></p>
<div>
<pre class="prettyprint linenums">a = [1, 2, [1, 2, 3]]<br />
b = a.copy()<br />
print(a)<br />
print(b)

a.append(4)<br />
a[2][0] = 0<br />
print(a)<br />
print(b)</pre>
</div>
<p>输出结果：</p>
<p>[1, 2, [1, 2, 3]]<br />
[1, 2, [1, 2, 3]]<br />
[1, 2, [0, 2, 3], 4]<br />
[1, 2, [0, 2, 3]]</p>
<p>浅copy只复制了第一层数据，列表里存储的子列表其实储存的是内存地址，所以只复制了子列表的地址，当子列表变化时跟着变化</p>
<p><strong>深copy：</strong></p>
<div>
<pre class="prettyprint linenums">import copy<br />
a = [1, 2, [1, 2, 3]]<br />
b = copy.deepcopy(a)<br />
print(a)<br />
print(b)

a.append(4)<br />
a[2][0] = 0<br />
print(a)<br />
print(b)</pre>
</div>
<p>输出结果：</p>
<p>[1, 2, [1, 2, 3]]<br />
[1, 2, [1, 2, 3]]<br />
[1, 2, [0, 2, 3],4]<br />
[1, 2, [1, 2, 3]]</p>
<p>同样的操作，换成深copy之后，复制之后子列表中的值不会跟着变化（将原来的数据完全复制了一遍）</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e53le8.html">ftl 问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rwrg7q.html">Docker 总结&lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2emzwq.html">Instagram的持续部署技术</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j7wyg9.html">Hibernate的关联映射&mdash;&mdash;单向1-1关联</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m0lr69.html">STL的string和wstring</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xrjle8.html">C&num; 时间现实问题（12小时制与24小时制）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okr11x9.html">mysql中的timestamp类型时间比较：unix&lowbar;timestamp函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/96orj2v9.html">bootstrap瀑布流代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1v4oj9.html">RTSP Monitor的总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z3ykz9.html">&lbrack;ES6&rsqb; Objects create-shorthand &amp;amp&semi;&amp;amp&semi; Destructuring</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojy501q.html">Luogu 1559 运动员最佳匹配问题（带权二分图最大匹配）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjpmyy8.html">Hibernate（十）：n-n关联关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz7ppl8.html">解决 Popup 位置不随窗口移动更新的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpglj59.html">转log4cxx&colon; Could not read configuration file &lbrack;log4cxx&period;properties&rsqb;解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdrnyz9.html">05 入门 - 浅谈 ASP&period;NET MVC程序的工作原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2j7d19.html">sklearn&period;model&lowbar;selection&period;StratifiedShuffleSplit</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vzoo2q.html">CSS3实现各种表情</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kwz5xq.html">【PAT】1103 Integer Factorization（30 分）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmgooe9.html">maven项目如何生成war文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pewln8.html">python学习&lpar;十七&rpar; 爬取MM图片</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv2j57y9.html">Cocos Creator 使用protobu&fjlig;s</a>
			</li>
						<li><a href="https://www.batexi.com/a/960loov9.html">&lbrack;JSTL - fmt&rsqb; fmt标签格式化日期</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w3xrwq.html">VSCode汉化</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r4r7n9.html">HostPort和NodePort</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd62dv9.html">js如何实现sign算法验证？</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w3jpgq.html">CUDA编程常见问题 转</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllwoxxq.html">Win10系列：C&num;应用控件基础19</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25g0llq.html">SQL-61 对于employees表中，给出奇数行的first&lowbar;name</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e43onj9.html">1091 N-自守数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwgzj79.html">OO课程中IDEA相关插件的使用</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
